#ifndef _MCDPROFILE_H
#define _MCDPROFILE_H

#ifndef STATS_MCD
#   define STATS_MCD                    0
#endif

#ifndef PROFILE_MCD
#   define PROFILE_MCD                  0
#endif

#if (STATS_MCD)
#   define McdStatsDo(E)                (E)
#   if (STATS_MCD >= 2)
#       define McdStatsLog(L)           MeInfo L
#   endif
#endif

#if (!defined McdStatsDo)
#   define McdStatsDo(E)                ((void) 0)
#endif
#if (!defined McdStatsLog)
#   define McdStatsLog(L)               ((void) 0)
#endif

#if (PROFILE_MCD)
#   include <MeProfile.h>
#   if 1
#       define McdProfileStart(s)       MeProfileStartSection(s,0)
#       define McdProfileEnd(s)         MeProfileEndSection(s)
#   elif (__GNUC__)
        static __inline void McdProfileStart(const char *const s)
        { MeProfileStartSection(s,0); }
        static __inline void McdProfileEnd(const char *const s)
        { MeProfileEndSection(s); }
#   elif (_MSC_VER)
        static _inline void McdProfileStart(const char *const s)
        { MeProfileStartSection(s,0); }
        static _inline void McdProfileEnd(const char *const s)
        { MeProfileEndSection(s); }
#   else
#       define McdProfileStart(s)       MeProfileStartSection(s,0)
#       define McdProfileEnd(s)         MeProfileEndSection(s)
#   endif
#endif

#if (!defined McdProfileStart)
#   define McdProfileStart(s)           ((void) 0)
#endif
#if (!defined McdProfileEnd)
#   define McdProfileEnd(s)             ((void) 0)
#endif

#endif
